//{$WARNINGS OFF}
//{$WARN SYMBOL_PLATFORM OFF}
//{$WARN UNIT_PLATFORM OFF}
//=============================================================================
//  TWebBrowser ŕ\̃EFuy[W̃N擾
//
//-----------------------------------------------------------------------------
//
//  ygpz
//
//  TCg̃AvP[VށCR|[lgCR[hނ́C]ځCρCzz
//  (IWiCϔ)Ȃǂ͑SĎRłDppRłDACgp̋L
//  ڋ`܂DIWî̂pƂ邱Ƃ͋֎~܂D
//  ȂC{TCg̃vOR[hgpƂɂĐCȂ
//  QCɊւĂ҂͈؊֗^Ȃ̂Ƃ܂DD
//
//-----------------------------------------------------------------------------
//
//  yz
//
//  2015N0302 `
//
//-----------------------------------------------------------------------------
//
//  ymFz
//
//  Windows 7 U64(SP1) + Delphi XE(UP1) Pro + Indy 10 (Ver 10.5.7)
//
//  Presented by Mr.XRAY
//  http://mrxray.on.coocan.jp/
//=============================================================================
unit UnitIE;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, MSHTML, OleCtrls, SHDocVw;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    Edit1: TEdit;
    Button1: TButton;
    Memo1: TMemo;
    WebBrowser1: TWebBrowser;
    Splitter1: TSplitter;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private 錾 }
    procedure CheckDuplicateItems(AList: TStringList);
    function ToAbsoluteURLPath(ATargetURL, ARelativeURL: string): string;
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

uses
  IOUtils,
  IdURI,
  StrUtils,
  Generics.Collections;

{$R *.dfm}

//=============================================================================
//  tH[̏
//=============================================================================
procedure TForm1.FormCreate(Sender: TObject);
begin
  Edit1.Text := 'http://mrxray.on.coocan.jp/Delphi/plSamples/003_StopWatch.htm';
end;

//=============================================================================
//  EFuy[WICŕ\ɁC̃y[WHTMLR[h
//    ̃y[Wւ̃N
//    gpĂX^CV[gCJavaScriptt@C̏ꏊ
//  擾ĕ\
//
//  (1) getAttributȇ2̒l0̎4̏ꍇ̃eXg
//  (2)  URL  URL ɕϊꍇ̃eXg
//=============================================================================
procedure TForm1.Button1Click(Sender: TObject);
var
  LSourceFile  : string;
  LIHTMLDoc2   : IHTMLDocument2;
  i            : Integer;
  LElementColl : IHTMLElementCollection;
  LElement     : IHTMLElement;
  LListLinkURL : TStringList;
  LValue       : string;
  LIFlags      : Integer;
begin
  Memo1.Lines.Clear;
  LSourceFile := Edit1.Text;

  if CheckBox1.Checked then begin
    LIFlags := 4;
  end else begin
    LIFlags := 0;
  end;

  // EFuy[W TWebBrowse ŕ\
  WebBrowser1.Navigate(LSourceFile);

  // ܂ő҂
  while WebBrowser1.ReadyState < READYSTATE_INTERACTIVE do begin
    Application.ProcessMessages;
    Sleep(1);
  end;

  // IHTMLDocument2 IuWFNg擾
  if Assigned(WebBrowser1.Document) then begin
    LIHTMLDoc2 := WebBrowser1.Document as IHTMLDocument2;

    // ÔreadState complete ɂȂ܂ő҂
    // uEUłȂꍇ = 'loading' łȂƉiv[vɂȂ
    while LIHTMLDoc2.readyState <> 'complete' do begin
      Application.ProcessMessages;
      Sleep(1);
    end;

    LListLinkURL := TStringList.Create;
    try
      // ȍ~ۂ HTML ̉
      LElementColl := LIHTMLDoc2.all;

      for i := 0 to LElementColl.length - 1 do begin
        LElement := LElementColl.item(i, '') as IHTMLElement;

        LValue := '';
        // w^O̎w葮̒lo
        if LElement.tagName = 'FRAME' then begin
          LValue    := LElement.getAttribute('src', LIFlags);
        end else
        if LElement.tagName = 'IFRAME' then begin
          LValue := LElement.getAttribute('src', LIFlags);
        end else
        if LElement.tagName = 'BODY' then begin
          LValue := LElement.getAttribute('background', LIFlags);
        end else
        if LElement.tagName = 'LINK' then begin
          LValue := LElement.getAttribute('href', LIFlags);
        end else
        if LElement.tagName = 'SCRIPT' then begin
          LValue := LElement.getAttribute('src', LIFlags);
        end else
        if LElement.tagName = 'A' then begin
          LValue := LElement.getAttribute('href', LIFlags);
        end else
        if LElement.tagName = 'IMG' then begin
          LValue := LElement.getAttribute('src', LIFlags);
        end;

        if LValue <> '' then begin
          //  URL  URL ɕϊ
          if CheckBox2.Checked then begin
            LValue := ToAbsoluteURLPath(LSourceFile, LValue);
          end;

          // y[W̃N .cgi t@C͏O
          if not (LeftStr(LValue, 1) = '#') then begin
            if not ContainsText(LValue, '.cgi') then begin
              // Xgɒǉ
              LListLinkURL.Add(LValue);
            end;
          end;
        end;
        Application.ProcessMessages;
      end;

      if LListLinkURL.Count = 0 then begin
        Memo1.Text := 'NȂ';
      end else begin
        // dĂ URL 擾Xg폜
        CheckDuplicateItems(LListLinkURL);
        Memo1.Text := LListLinkURL.Text;
      end;
    finally
      FreeAndNil(LListLinkURL);
    end;
  end;

  LIHTMLDoc2 := nil;
end;

//-----------------------------------------------------------------------------
//  HTML R[h̃N̑ URL  URL ɕϊ֐
//
//  ATargetURL   : EFuy[W̃AhX
//                 fBNg̏ꍇ́CɃf~^ (/) Kv
//                 / Ȃ΃t@CƌȂ
//  ARelativeURL : ΃pX擾΃pX (΃pXł悢)
//  ߂l         ΃pX΃pXɕϊl
//                 TCgÕAhX̎́C RelativeURL ̂܂
//                 y[W̃N̂܂ (擪 #)
//-----------------------------------------------------------------------------
function TForm1.ToAbsoluteURLPath(ATargetURL, ARelativeURL: string): string;
var
  LBaseDir       : string;
  LProtocol      : string;
  LRelativeURL   : string;
  LIdURL         : TIdURI;
  LHomeDirectory : string;
begin
  Result       := '';
  LBaseDir     := ATargetURL;
  LRelativeURL := ARelativeURL;
  if LBaseDir = '' then exit;
  if LRelativeURL = '' then exit;

  // z[fBNg URL 擾Ă
  LIdURL := TIdURI.Create(ATargetURL);
  try
    LProtocol      := LIdURL.Protocol + ':';
    LHomeDirectory := LIdURL.Protocol + '://' + LIdURL.Host;
  finally
    FreeAndNil(LIdURL);
  end;


  // z[fBNg URL ܂܂Ă΂łɐ΃oXƌȂ
  if ContainsText(LRelativeURL, LHomeDirectory) then begin
    Result := LRelativeURL;
  end else begin
    // 擾N̑΃pX̐擪 about: ܂ about:/ ƂȂ炵
    // y[W̃N about:blank ƂȂ炵
    // 폜Ă
    LRelativeURL := StringReplace(LRelativeURL, 'about:blank', '', [rfIgnoreCase]);
    LRelativeURL := StringReplace(LRelativeURL, 'about:', '', [rfIgnoreCase]);

    //擪[//]̎̓vgRɑ΂鑊΃pX
    if (LeftStr(LRelativeURL, 2) = '//') then begin
      Result := LProtocol + LRelativeURL;
    end else
    // 擪 [/] ̎̓TCg[g΃pX
    if (LeftStr(LRelativeURL, 1) = '/') then begin
      Insert(LHomeDirectory, LRelativeURL, 1);
      Result := LRelativeURL;
    end else
    // [./] ͓fBNg𖾎Iɕ\̋Lq
    if (LeftStr(LRelativeURL, 2) = './') then begin
      Delete(LRelativeURL, 1, 2);
      Result := LRelativeURL;
    end else begin
      //[../]Ȃꍇ͓fBNg܂͑̃TCgւ̃N
      if not ContainsText(LRelativeURL, '../') then begin
        // [://] Ƃ񂪂Α̃TCgƌȂ
        if ContainsText(LRelativeURL, '://') then begin
          Result := LRelativeURL;
        end else begin
          if LeftStr(LRelativeURL, 1) = '#' then begin
            Result := LRelativeURL;
          end else begin
            Result := TPath.GetDirectoryName(LBaseDir) + '/' + LRelativeURL;
          end;
        end;
      end else begin
        // [../] ̐̊Kw̃fBNg擾Ă
        while True do begin
          LBaseDir := TPath.GetDirectoryName(LBaseDir);
          if LeftStr(LRelativeURL, 3) <> '../' then break;
          Delete(LRelativeURL, 1, 3);
        end;
        LBaseDir := LBaseDir + '/';
        if ContainsText(LBaseDir, LHomeDirectory) then begin
          Result := LBaseDir + LRelativeURL;
        end;
      end;
    end;
  end;
end;

//-----------------------------------------------------------------------------
//  Xg̏d폜郋[`
//  uses  Generics.Collections Kv
//-----------------------------------------------------------------------------
procedure TForm1.CheckDuplicateItems(AList: TStringList);
var
  LListDic  : TDictionary<String,TObject>;
  LListTemp : TStringList;
  LIndex    : Integer;
begin
  // d URL OTMemo ɒǉĂ
  LListDic  := TDictionary<String, TObject>.Create;
  LListTemp := TStringList.Create;
  try
    LListTemp.Text := AList.Text;
    AList.Clear;
    for LIndex := 0 to LListTemp.Count - 1 do begin
      if LListDic.ContainsKey(LListTemp[LIndex]) = False then begin
        LListDic.Add(LListTemp[LIndex], nil);
        AList.Add(LListTemp[LIndex]);
      end;
    end;
  finally
    FreeAndNil(LListDic);
    FreeAndNil(LListTemp);
  end;
end; 

end.
