//{$WARNINGS OFF}
//{$WARN SYMBOL_PLATFORM OFF}
//{$WARN UNIT_PLATFORM OFF}
//=============================================================================
//   URL  URL ɕϊ֐Ƃ̃eXg
//
//-----------------------------------------------------------------------------
//
//  ygpz
//
//  TCg̃AvP[VށCR|[lgCR[hނ́C]ځCρCzz
//  (IWiCϔ)Ȃǂ͑SĎRłDppRłDACgp̋L
//  ڋ`܂DIWî̂pƂ邱Ƃ͋֎~܂D
//  ȂC{TCg̃vOR[hgpƂɂĐCȂ
//  QCɊւĂ҂͈؊֗^Ȃ̂Ƃ܂DD
//
//-----------------------------------------------------------------------------
//
//  yz
//
//  2015N0302 `
//
//-----------------------------------------------------------------------------
//
//  ymFz
//
//  Windows 7 U64(SP1) + Delphi XE(UP1) Pro + Indy 10 (Ver 10.5.7)
//
//  Presented by Mr.XRAY
//  http://mrxray.on.coocan.jp/
//=============================================================================
unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Memo1: TMemo;
    Edit1: TEdit;
    Edit2: TEdit;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private 錾 }
    function ToAbsoluteURLPath(ATargetURL, ARelativeURL: string): string;
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

uses 
  IdURI,
  IOUtils,
  StrUtils;

{$R *.dfm}

//=============================================================================
//  tH[̏
//=============================================================================
procedure TForm1.FormCreate(Sender: TObject);
begin
  Edit1.Text := 'http://mrxray.on.coocan.jp/Delphi/plSamples/949_ParseHTML.htm';
  Edit2.Text := '../AAA.txt';
end;

//=============================================================================
//  ̊֐̃eXg
//=============================================================================
procedure TForm1.Button1Click(Sender: TObject);
var
  LLinkFullPath : String;
begin
  Memo1.Lines.Clear;
  LLinkFullPath := ToAbsoluteURLPath(Edit1.Text, Edit2.text);
  Memo1.Lines.Add(LLinkFullPath);
end;

//-----------------------------------------------------------------------------
//  HTML R[h̃N̑ URL  URL ɕϊ֐
//
//  ATargetURL   : EFuy[W̃AhX
//                 fBNg̏ꍇ́CɃf~^ (/) Kv
//                 / Ȃ΃t@CƌȂ
//  ARelativeURL : ΃pX擾΃pX (΃pXł悢)
//  ߂l         ΃pX΃pXɕϊl
//                 TCgÕAhX̎́C RelativeURL ̂܂
//                 y[W̃N̂܂ (擪 #)
//-----------------------------------------------------------------------------
function TForm1.ToAbsoluteURLPath(ATargetURL, ARelativeURL: string): string;
var
  LBaseDir       : string;
  LProtocol      : string;
  LRelativeURL   : string;
  LIdURL         : TIdURI;
  LHomeDirectory : string;
begin
  Result       := '';
  LBaseDir     := ATargetURL;
  LRelativeURL := ARelativeURL;
  if LBaseDir = '' then exit;
  if LRelativeURL = '' then exit;

  // z[fBNg URL 擾Ă
  LIdURL := TIdURI.Create(ATargetURL);
  try
    LProtocol      := LIdURL.Protocol + ':';
    LHomeDirectory := LIdURL.Protocol + '://' + LIdURL.Host;
  finally
    FreeAndNil(LIdURL);
  end;


  // z[fBNg URL ܂܂Ă΂łɐ΃oXƌȂ
  if ContainsText(LRelativeURL, LHomeDirectory) then begin
    Result := LRelativeURL;
  end else begin
    // 擾N̑΃pX̐擪 about: ܂ about:/ ƂȂ炵
    // y[W̃N about:blank ƂȂ炵
    // 폜Ă
    LRelativeURL := StringReplace(LRelativeURL, 'about:blank', '', [rfIgnoreCase]);
    LRelativeURL := StringReplace(LRelativeURL, 'about:', '', [rfIgnoreCase]);

    //擪[//]̎̓vgRɑ΂鑊΃pX
    if (LeftStr(LRelativeURL, 2) = '//') then begin
      Result := LProtocol + LRelativeURL;
    end else
    // 擪 [/] ̎̓TCg[g΃pX
    if (LeftStr(LRelativeURL, 1) = '/') then begin
      Insert(LHomeDirectory, LRelativeURL, 1);
      Result := LRelativeURL;
    end else
    // [./] ͓fBNg𖾎Iɕ\̋Lq
    if (LeftStr(LRelativeURL, 2) = './') then begin
      Delete(LRelativeURL, 1, 2);
      Result := LRelativeURL;
    end else begin
      //[../]Ȃꍇ͓fBNg܂͑̃TCgւ̃N
      if not ContainsText(LRelativeURL, '../') then begin
        // [://] Ƃ񂪂Α̃TCgƌȂ
        if ContainsText(LRelativeURL, '://') then begin
          Result := LRelativeURL;
        end else begin
          if LeftStr(LRelativeURL, 1) = '#' then begin
            Result := LRelativeURL;
          end else begin
            Result := TPath.GetDirectoryName(LBaseDir) + '/' + LRelativeURL;
          end;
        end;
      end else begin
        // [../] ̐̊Kw̃fBNg擾Ă
        while True do begin
          LBaseDir := TPath.GetDirectoryName(LBaseDir);
          if LeftStr(LRelativeURL, 3) <> '../' then break;
          Delete(LRelativeURL, 1, 3);
        end;
        LBaseDir := LBaseDir + '/';
        if ContainsText(LBaseDir, LHomeDirectory) then begin
          Result := LBaseDir + LRelativeURL;
        end;
      end;
    end;
  end;
end;

end.
